Description

History

#1 - 02/26/2013 05:01 AM - Costin Savin

Next error is in .../vcpl/daqueau0.p:

EXPRESSION EXECUTION ERROR:

---------------------------

throwException( sprintf("Unknown expression return type:  %s", rettype), this)

^  { Unknown expression return type:  rowid [FUNC_ROWID id <99845104744947> 2599:78] }

---------------------------

ERROR:

java.lang.RuntimeException: ERROR!  Active Rule:

-----------------------

      RULE REPORT      

-----------------------

Rule Type :   WALK

Source AST:  [ ROWID ] BLOCK/PROCEDURE/BLOCK/STATEMENT/KW_IF/KW_THEN/INNER_BLOCK/BLOCK/STATEMENT/KW_IF/KW_THEN

/INNER_BLOCK/BLOCK/INNER_BLOCK/BLOCK/STATEMENT/KW_FIND/RECORD_PHRASE/KW_WHERE/EXPRESSION/EQUALS/FUNC_ROWID/ @2

599:78 {99845104744947}

Copy AST  :  [ ROWID ] BLOCK/PROCEDURE/BLOCK/STATEMENT/KW_IF/KW_THEN/INNER_BLOCK/BLOCK/STATEMENT/KW_IF/KW_THEN

/INNER_BLOCK/BLOCK/INNER_BLOCK/BLOCK/STATEMENT/KW_FIND/RECORD_PHRASE/KW_WHERE/EXPRESSION/EQUALS/FUNC_ROWID/ @2

599:78 {99845104744947}

Condition :  throwException( sprintf("Unknown expression return type:  %s", rettype), this)

Loop      :  false

--- END RULE REPORT ---

 

This is occurring in annotations/where_clause_post2.rules. Looks like we need to add rowid (and recid) into the vartypes map. I think this means we

need similar changes to the exptypes map above it. Note that classes RowidExpression and RecidExpression do not currently exist.
#2 - 02/26/2013 08:53 AM - Costin Savin

Is there any case for RECID I can use?

For ROWID I testedn the changes with something like FIND FIRST book WHERE TO-ROWID(book.price) = ROWID(customer) NO-LOCK

NO-ERROR.

but for RECID there is no equivalent to TO-ROWID

#3 - 02/26/2013 09:11 AM - Constantin Asofiei

Costin, use this test:

function func0 returns recid(buffer bb for book). end.

find first book where func0(book.book-id) = recid(book).

#4 - 02/26/2013 09:59 AM - Costin Savin

- File cs_upd20130226b.zip added

Derived a case from that for recid

Added proposed update.

#5 - 02/26/2013 10:14 AM - Constantin Asofiei

I'm reviewing this now.

#6 - 02/26/2013 10:17 AM - Constantin Asofiei

Beside the header in RecidExpression (where you reference RowidExpression), I don't see any problems. I'm putting this into conversion regression

testing on my system.

#7 - 02/26/2013 11:08 AM - Costin Savin

- File cs_upd20130226c.zip added

Eliminated the problems from previous update

#8 - 02/26/2013 12:26 PM - Constantin Asofiei

Conversion regression testing has passed, please check in and distribute update.

#9 - 02/26/2013 12:37 PM - Costin Savin

Commited to bzr as revision 10212.

#10 - 02/26/2013 05:54 PM - Eric Faulhaber

- Status changed from New to Closed

- % Done changed from 0 to 100

#11 - 11/16/2016 11:07 AM - Greg Shah

- Target version changed from Milestone 4 to Conversion Support for Server Features

#12 - 11/18/2016 11:36 AM - Greg Shah
- Description updated

Files

cs_upd20130226b.zip 7.23 KB 02/26/2013 Costin Savin

cs_upd20130226c.zip 7.23 KB 02/26/2013 Costin Savin
